using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.ComponentModel;

namespace ZipTest
{
    class Program
    {
        // These are the Win32 error code for file not found or access denied.
        const int ERROR_FILE_NOT_FOUND = 2;
        const int ERROR_ACCESS_DENIED = 5;

        static readonly string COMMMND = "zip.exe";
        static readonly string OPTIONS = "-r ";

        static void Main(string[] args)
        {
            Program prog = new Program();

            prog.Archive(string.Join(" ", args));
        }

        void Archive(string arguments)
        {
            try
            {
                Console.WriteLine(OPTIONS + arguments);

                Process process = new Process();
                process.StartInfo.FileName = COMMMND;
                process.StartInfo.Arguments = OPTIONS + arguments;
                process.StartInfo.UseShellExecute = false;
                process.StartInfo.RedirectStandardError = true;
                process.Start();
                string stderr = process.StandardError.ReadToEnd();
                process.WaitForExit();

                Console.WriteLine("ExitCode : " + process.ExitCode);
                Console.WriteLine("StdErr : " + stderr);
            }
            catch (Win32Exception e)
            {
                if (e.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                {
                    Console.WriteLine(e.Message + ". Check the path.");
                }
                else if (e.NativeErrorCode == ERROR_ACCESS_DENIED)
                {
                    // Note that if your word processor might generate exceptions
                    // such as this, which are handled first.
                    Console.WriteLine(e.Message +
                        ". You do not have permission to print this file.");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("Exception Occued.", e);
            }
        }
    }//eof class
}//eof namespace
